/***************************************************************************
                          markupdialog.cpp  -  description
                             -------------------
    begin                : Mon Dez 29 2003
    copyright            : (C) 2003 by Nicola D�elin
    email                : adoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "markupdialog.h"
#include <qinputdialog.h>
#include <qwhatsthis.h>

MarkupDialog::MarkupDialog(QWidget *parent, const char *name )
: MarkupDlg(parent,name) 
{
}

MarkupDialog::~MarkupDialog()
{
}


void MarkupDialog::addItem()
{
  bool ok;
  QString s = QInputDialog::getText(tr("New Macro"), tr("Enter new Command:"), 
                                    QLineEdit::Normal, "\\newcommand*{}{}", &ok, this);
  if (ok && !s.isEmpty()) listBoxMain->insertItem(s, -1);
}

void MarkupDialog::removeItem()
{
  if (!listBoxMain->count()) return;

  int i = listBoxMain->currentItem();
  listBoxMain->removeItem(i);
}

void MarkupDialog::modifyItem()
{
  if (!listBoxMain->count()) return;
  bool ok;
  int i = listBoxMain->currentItem();
  QString s = listBoxMain->currentText();
  QString t = QInputDialog::getText(tr("Modify Macro"), tr("Enter Command:"), 
                                    QLineEdit::Normal, s, &ok, this);

  if (ok && !t.isEmpty()) listBoxMain->changeItem(t, i);
}

void MarkupDialog::defaultEntries()
{
  QStringList lst;
  lst.push_back("\\newcommand*{\\FigB}{fig.}      % \"fig.\" as used in brackets");
  lst.push_back("\\newcommand*{\\FigT}{figure}    % \"figure\" as used in running text");
  lst.push_back("\\newcommand*{\\FigsT}{figures}  % \"figures\" (plural) in running text");
  lst.push_back("\\newcommand*{\\TabB}{tab.}      % \"tab.\" as used in brackets");
  lst.push_back("\\newcommand*{\\TabT}{table}     % \"table\" as used in running text");
  lst.push_back("\\newcommand*{\\TabsT}{tables}   % \"tables\" (plural) used in running text");

  listBoxMain->insertStringList(lst, -1);
}


/* public slots */

QStringList MarkupDialog::getList()
{
  QStringList lst;
  for (uint i = 0; i < listBoxMain->count(); i++) {
    lst.push_back(listBoxMain->text((int)i));
  }
  return lst;
}

void MarkupDialog::setList(const QStringList &l) 
{
  listBoxMain->insertStringList(l);
}


void MarkupDialog::whatsThis()
{
  QWhatsThis::enterWhatsThisMode();
}
