/***************************************************************************
                          pkgadddialog.cpp  -  description
                             -------------------
    begin                : Don Jan 8 2004
    copyright            : (C) 2004 by Nicola Dbelin
    email                : adoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pkgadddialog.h"
#include <qapplication.h>
#include <qdir.h>
#include <qfileinfo.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qstringlist.h>

PkgAddDialog::PkgAddDialog(QWidget *parent, const char *name ) : pkgAddDlg(parent,name) {

  connect(this, SIGNAL(styleFound(QString)), this, SLOT(insertStyle(QString)));
  scanning = false;
  
}
PkgAddDialog::~PkgAddDialog(){
}

void PkgAddDialog::setDirs(QString t, QString l)
{
  tdir = t;
  ltdir = l;
}

void PkgAddDialog::slotScan()
{

  if (scanning) scanning = false;
  
  else {
    listBox->clear();
    scanning = true;
    buttonOk->setEnabled(false);
    buttonCancel->setEnabled(false);
    buttonScan->setText(tr("Abort"));
  
    textLabelStatus->setText(tr("Scanning..."));
    searchFiles(tdir);
    searchFiles(ltdir);
    textLabelStatus->setText("");
    textLabelDir->setText("");
    scanning = false;
    }

  buttonOk->setEnabled(true);
  buttonCancel->setEnabled(true);
  buttonScan->setText(tr("Scan"));
}

void PkgAddDialog::searchFiles(QString dir)
{
  QDir d(dir);
  QStringList t, s;
  QFileInfo f;

//  qDebug("Directory: " + dir);
  textLabelDir->setText(dir);
  d.setFilter(QDir::Dirs | QDir::Files | QDir::NoSymLinks);
  d.setSorting(QDir::Name);

  t = d.entryList();

  for (QStringList::Iterator it = t.begin(); it != t.end(); ++it) {
    if (!scanning) return;
    if ((*it == "..") || (*it == ".")) continue;
    f.setFile(d.absPath() + "/" + *it);
//    qDebug("Scanned file: " + f.absFilePath() + "/" + f.fileName());
    if (f.isFile())
      if (f.extension(false) == "sty") {
//        qDebug("Style found: " + f.absFilePath());
        emit styleFound(f.baseName(true));
        qApp->processEvents(100);
        }
    if (f.isDir())
      searchFiles(f.absFilePath());    
    }
}

void PkgAddDialog::insertStyle(QString s)
{
  listBox->insertItem(s, -1);
}
