/***************************************************************************
                          settingsdialog.h  -  description
                             -------------------
    begin                : Son Dez 7 2003
    copyright            : (C) 2003 by Nicola Dbelin
    email                : adoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <qfont.h>
#include <qfontdatabase.h>
#include <qstring.h>
#include <qwidget.h>
#include <settingsdlg.h>

/**
  *@author Nicola Dbelin
  */

class SettingsDialog : public SettingsDlg  {
   Q_OBJECT
public: 
	SettingsDialog(QWidget *parent=0, const char *name=0);
	~SettingsDialog();

  QFont getFont();
  void setFont(QFont);
  void setWd(QString);
  QString getWd();
  void setTd(QString);
  QString getTd();
  void setLtd(QString);
  QString getLtd();
  
private:
  QFont font;
  QFontDatabase fontDb;
  QString fontstr;

private slots:
  void familyChanged();
  void stylesChanged();
  void sizeChanged();
  void newSize();
  void wdChanged();
  void tdChanged();
  void ltdChanged();
  void allSaved();
  
};

#endif
