/***************************************************************************
                          templatedialog.cpp  -  description
                             -------------------
    begin                : Sam Nov 29 16:47:18 CET 2003
    copyright            : (C) 2003 by Nicola D�elin
    email                : ndoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "templatedialog.h"

#include <qinputdialog.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qstring.h>
#include <qstringlist.h>

TemplateDialog::TemplateDialog(QWidget *parent, const char *name ) : TemplateDlg(parent,name)
{
  templateList = new QPtrList<Template>();
  templateList->setAutoDelete(true);
}

TemplateDialog::~TemplateDialog()
{
}

void TemplateDialog::rename()
{
  rename(listBoxTemplates->selectedItem());
}

void TemplateDialog::rename(QListBoxItem *itm)
{
  int idx = listBoxTemplates->index(itm);
  if (idx >= templateList->count()) return;
  QString txt = listBoxTemplates->text(idx);
  bool ok;

  QString nm = QInputDialog::getText(tr("Rename Template"),
                                     tr("Enter new Name:"),
                                     QLineEdit::Normal,
                                     txt, &ok, this);

  if (!ok || nm.isEmpty()) return;

  listBoxTemplates->changeItem(nm, idx);
  Template *tpl = templateList->at(idx);
  tpl->setName(nm);
}

void TemplateDialog::remove()
{
  QListBoxItem *itm = listBoxTemplates->selectedItem();
  int idx = listBoxTemplates->index(itm);

  if (idx >= templateList->count()) return;

  listBoxTemplates->removeItem(idx);
  templateList->remove(idx);

  if (templateList->isEmpty()) listView->clear();
}

void TemplateDialog::currentItemChanged(QListBoxItem *itm)
{
  int idx = listBoxTemplates->index(itm);
  if (idx >= templateList->count()) return;

  Template *tpl = templateList->at(idx);
  QStringList lst = tpl->writeToStringList();

  listView->clear();

  QString par, val;
  QStringList::iterator it;
  for (it = lst.begin(); it != lst.end(); it++) {
    par = *it;
    it++;
    val = *it;

    new QListViewItem(listView, par, val);
  }
}

void TemplateDialog::setTemplates(const QPtrList<Template> &tl)
{
  *templateList = tl;
  Template *t;

  for (t = templateList->first(); t; t = templateList->next()) {
    listBoxTemplates->insertItem(t->name());
  }
}

const QPtrList<Template> & TemplateDialog::getTemplates()
{
  return *templateList;
}


